# {{ name }} pipeline

<!-- BADGIE TIME -->

[![pipeline status](https://img.shields.io/gitlab/pipeline-status/buildgarden/pipelines/helm?branch=main)](https://gitlab.com/buildgarden/pipelines/helm/-/commits/main)
[![latest release](https://img.shields.io/gitlab/v/release/buildgarden/pipelines/helm)](https://gitlab.com/buildgarden/pipelines/helm/-/releases)
[![pre-commit](https://img.shields.io/badge/pre--commit-enabled-brightgreen?logo=pre-commit)](https://github.com/pre-commit/pre-commit)
[![cici-tools enabled](https://img.shields.io/badge/%E2%9A%A1_cici--tools-enabled-c0ff33)](https://gitlab.com/buildgarden/tools/cici-tools)
[![code style: prettier](https://img.shields.io/badge/code_style-prettier-ff69b4.svg)](https://github.com/prettier/prettier)

<!-- END BADGIE TIME -->

{%- include "brief.md.j2" %}

> Do not use this software unless you are an active collaborator on the
> associated research project.
>
> This project is an output of an ongoing, active research project. It is
> published without warranty, is subject to change at any time, and has not been
> certified, tested, assessed, or otherwise assured of safety by any person or
> organization. Use at your own risk.

{%- include "description.md.j2" %}

{%- include "groups.md.j2" %}

## Use cases

### All includes

Add the following to your `.gitlab-ci.yml` file to enable all targets:

```yaml
include:
  - project: buildgarden/pipelines/python
    file:
      - python-autoflake.yml
      - python-black.yml
      - python-build-wheel.yml
      - python-build-sdist.yml
      - python-deptry.yml
      - python-docformatter.yml
      - python-import-linter.yml
      - python-isort.yml
      - python-mypy.yml
      - python-pyroma.yml
      - python-pytest.yml
      - python-twine-upload.yml
      - python-vulture.yml
```

### All hooks

Add the following to your `.pre-commit-config.yaml` file to enable all targets:

```yaml
repos:
  - repo: https://gitlab.com/buildgarden/pipelines/python
    hooks:
      - id: python-autoflake
      - id: python-black
      - id: python-deptry
      - id: python-docformatter
      - id: python-import-linter
      - id: python-isort
      - id: python-pip-compile
      - id: python-pyroma
      - id: python-vulture
```

### Static analysis tools

The following linters are available for use:

```yaml
include:
  - project: buildgarden/pipelines/python
    file:
      - python-autoflake.yml
      - python-black.yml
      - python-isort.yml
      - python-mypy.yml
      - python-pyroma.yml
      - python-vulture.yml
```

### Run unit tests

Run pytest unit tests:

```yaml
include:
  - project: buildgarden/pipelines/python
    file:
      - python-pytest.yml
```

### Customize the behavior of `autoflake`

The following settings are the default options. Paste into your CI file to
customize:

```yaml
variables:
  PYTHON_AUTOFLAKE_OPTS: >-
    --remove-duplicate-keys
    --remove-unused-variables
    --expand-star-imports
    --remove-all-unused-imports
```

### Use `black` and `isort` together

The following minimal configuration is required in your `pyproject.toml` file:

```toml
[tool.isort]
profile = "black"
```

`known_first_party` is also recommended to use the linter without a complete
local environment:

```toml
[tool.isort]
known_first_party = ["python_pipeline"]
profile = "black"
```

### Build and publish

Build a package with setuptools and publish the package to a PyPI repository.

```yaml
include:
  - project: buildgarden/pipelines/python
    file:
      - python-build-sdist.yml
      - python-build-wheel.yml
      - python-twine-upload.yml
```

### Publish the package

By default, this pipeline publishes to GitLab's PyPI Package Registry.

The pipeline can be used to publish to PyPI by setting the following variables:

- `PYTHON_PYPI_UPLOAD_URL` = `https://upload.pypi.org/legacy/`
- `PYTHON_PYPI_USERNAME` = `__token__`
- `PYTHON_PYPI_PASSWORD` - Your API token

### Using Packages

#### Locally

Create the config directory:

```
mkdir -p ~/.config/pip
```

Create a `pip.conf` file:

```
$ cat ~/.config/pip/pip.conf
[global]
index-url = https://__token__:<read_api-token>gitlab.com/api/v4/groups/<group-id>/-/packages/pypi/simple
```

Install a package. GitLab will pull from [pypi.org](https://pypi.org) if the
package is not found.

```
$ pip install python-decouple
Looking in indexes: https://__token__:****@gitlab.com/api/v4/projects/32517826/packages/pypi/simple
Collecting python-decouple
  Downloading python_decouple-3.5-py3-none-any.whl (9.6 kB)
Installing collected packages: python-decouple
Successfully installed python-decouple-3.5
```

#### In CI

The most sensible way to use packages from the GitLab Package Registry is to
pull them from the root namespace registry. This ensures that any packages your
user may have access to are available for use.

The `CI_JOB_TOKEN` cannot be used to determine the group ID by name, so it must
be provided upfront. This is preferred to using a deploy token, so that the
permissions are specific to your user and not blanket.

Define the `PYTHON_PYPI_GITLAB_GROUP_ID` variable in your CI file, or ask a
group owner to add it to CI variables.

{%- include "targets.md.j2" %}

{%- include "variables.md.j2" %}
